// test speed

RequireScript("suite.js");

function Obj1() {
	this.num = 0;
	
	this.update = function() {
		this.num += 2;
		this.num -= 2;
	}
}

function Obj2() {
	this.num = 0;
}

Obj2.prototype.update = function() {
	this.num += 2;
	this.num -= 2;
}

function Obj3() {
	this.num = 0;
}

Obj3.prototype = {	
	update: function() {
		this.num += 2;
		this.num -= 2;
	}
}

var Obj4 = (function() {
	function Update() {
		this.num += 2;
		this.num -= 2;
	}
	
	function Obj() {
		this.num = 0;
	}
	
	Obj.prototype.update = Update;
	return Obj;
})();

var p = "";
function Print(text) { p += text + "\n"; }

function game() {
	var s = new Suite;
	var o1 = new Obj1();
	var o2 = new Obj2();
	var o3 = new Obj3();
	var o4 = new Obj4();
	
	s.add("1", function() { for (var i = 0; i < 100; ++i) { var n = new Obj1(); n.update(); } }, 1000);
	s.add("2", function() { for (var i = 0; i < 100; ++i) { var n = new Obj2(); n.update(); } }, 1000);
	s.add("3", function() { for (var i = 0; i < 100; ++i) { var n = new Obj3(); n.update(); } }, 1000);
	s.add("4", function() { for (var i = 0; i < 100; ++i) { var n = new Obj4(); n.update(); } }, 1000);
	s.on("cycle", function(t) { Print(t.target); }).run();
	Abort(p);
}
